/*
 The set S originally contains numbers from 1 to n. But unfortunately, due to the data error, one of the numbers in the set got duplicated to another number in the set, which results in repetition of one number and loss of another number.
 
 Given an array nums representing the data status of this set after the error. Your task is to firstly find the number occurs twice and then find the number that is missing. Return them in the form of an array.
 
 Example 1:
 Input: nums = [1,2,2,4]
 Output: [2,3]
 
 Note:
 The given array size will in the range [2, 10000].
 The given array's numbers won't have any order.
 */

class Solution {
    func findErrorNums(_ nums: [Int]) -> [Int] {
        let sortedNums = nums.sorted()

        var sum = 0
        var sum2 = 0
        var preNum = 0
        var repeatNum = 0
        
        for index in 0 ..< sortedNums.count {
            
            sum += index + 1
            sum2 += sortedNums[index]
            
            if preNum == sortedNums[index] {
                repeatNum = sortedNums[index]
            }
            preNum = sortedNums[index]
        }
        return [repeatNum, repeatNum + sum - sum2]
    }
}

Solution().findErrorNums([1,5,3,2,2,7,6,4,8,9])
